diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/group.c tin-2.6.5/src/group.c
--- tin-2.6.4/src/group.c	2024-12-03 09:29:39.000000000 +0100
+++ tin-2.6.5/src/group.c	2025-11-27 11:35:43.002715263 +0100
@@ -3,10 +3,10 @@
  *  Module    : group.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-02
+ *  Updated   : 2025-11-16
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -158,7 +158,6 @@ group_page(
 	int thread_depth;	/* Starting depth in threads we enter */
 	t_artnum old_artnum;
 	struct t_art_stat sbuf;
-	struct t_article *art;
 	t_bool flag;
 	t_bool xflag = FALSE;	/* 'X'-flag */
 	t_bool repeat_search;
@@ -182,12 +181,29 @@ group_page(
 	/*
 	 * update index file. quit group level if user aborts indexing
 	 */
-	if (!index_group(group)) {
+	if (!index_group(group, TRUE)) {
+		/*
+		 * can't see how this ever could leak, so why bother?
+		 * (next index_group() or tin_done() will take care
+		 * of the free()s and nothing else should modify arts[])
+		 * and if, why not also clear xref and mailbox.next?
+		 * (use free_art_array() then)
+		 */
+#if 0
+		struct t_article *art;
+
 		for_each_art(i) {
 			art = &arts[i];
 			FreeAndNull(art->refs);
 			FreeAndNull(art->msgid);
+			/* FreeAndNull(art->xref); */
+			/* free_mailbox_list(art->mailbox.next); */
 		}
+		/*
+		 * the obove is more or less free_art_array()
+		 * why not also do hash_reclaim() here?
+		 */
+#endif /* 0 */
 		curr_group = NULL;
 		tin_errno = 0;
 		return GRP_RETSELECT;
@@ -378,14 +394,96 @@ group_page(
 				if (invoke_editor(filter_file, filter_file_offset, NULL)) {
 					old_artnum = grpmenu.max > 0 ? arts[(int) base[grpmenu.curr]].artnum : T_ARTNUM_CONST(-1);
 					unfilter_articles(group);
-					(void) read_filter_file(filter_file);
-					filter_articles(group);
+					if (read_filter_file(filter_file))
+						filter_articles(group);
 					make_threads(group, FALSE);
 					grpmenu.curr = old_artnum >= T_ARTNUM_CONST(0) ? find_new_pos(old_artnum, grpmenu.curr) : grpmenu.max - 1;
 				}
 				show_group_page();
 				break;
 
+			/*
+			 * mark all articles older than <days> or <rfc5322-date-string> as read.
+			 * useful when subscribing to a new group with high-traffic.
+			 *
+			 * TODO: - do we need a [GROUP_]MARK_ANCIENT_ART_UNREAD?
+			 *       - shares a lot of code with
+			 *         select.c:selection_page():MARK_ANCIENT_ART_READ
+			 */
+			case MARK_ANCIENT_ART_READ:
+				{
+					char *p;
+					char tmp[LEN];
+					int days;
+					unsigned int cnt = 0;
+					t_bool only_unread = group->attribute->show_only_unread_arts;
+					time_t past = -1;
+
+					clear_message();
+					if (prompt_default_string(_(txt_group_mark_ancient_art_read), tmp, sizeof(tmp), NULL, HIST_OTHER)) {
+#ifdef HAVE_STRPTIME
+						struct tm tm;
+#endif /* HAVE_STRPTIME */
+
+						str_trim(tmp);
+
+#ifdef HAVE_STRPTIME
+						memset(&tm, 0, sizeof(tm));
+						if (strptime(tmp, *group->attribute->date_format, &tm))
+							past = mktime(&tm);
+#endif /* HAVE_STRPTIME */
+						if (past < 0 && (p = strchr(tmp, ' '))) { /* could be a date string, try to parse */
+							if ((past = parsedate(tmp, (struct _TIMEINFO *) 0)) < 0 && isalpha((unsigned char) tmp[0])) /* failed, try again with first "word" skipped */
+								past = parsedate(p + 1, (struct _TIMEINFO *) 0);
+						}
+
+						if (past < 0) { /* not a valid date string, then take the leading digits as days */
+							p = tmp;
+							if (*p == '-' || *p == '+') /* ignore one leading sign if present */
+								p++;
+							if (isdigit((unsigned char) *p)) {
+								if ((days = strtol(p, NULL, 10)) > 0) {
+									if (days <= (time((time_t *) 0) / DAY))
+										past = (time((time_t *) 0) - (days * DAY));
+								} else
+									past = -2;
+							}
+						}
+
+						if (past >= time((time_t *) 0)) /* also avoid "catchup" with past == time(0) */
+							past = -2;
+
+						switch (past) {
+							case -2:
+								info_message(_(txt_error_date_future), tmp);
+								break;
+
+							case -1:
+								info_message(_(txt_error_date_unparsable), tmp);
+								break;
+
+							default:
+								if (only_unread)
+									toggle_read_unread(FALSE);
+								for (n = 0; n < grpmenu.max; n++) {
+									for_each_art_in_thread(i, n) {
+										if (arts[i].status > ART_READ && arts[i].date < past) {
+											art_mark(curr_group, &arts[i], ART_READ);
+											++cnt;
+										}
+									}
+								}
+								if (only_unread)
+									toggle_read_unread(FALSE);
+								if (cnt)
+									show_group_page();
+								info_message(P_(txt_group_ancient_arts_marked_read_sp[0], txt_group_ancient_arts_marked_read_sp[1], cnt), cnt);
+								break;
+						}
+					}
+				}
+				break;
+
 			case GLOBAL_QUICK_FILTER_SELECT:		/* quickly auto-select article */
 			case GLOBAL_QUICK_FILTER_KILL:			/* quickly kill article */
 				if (grpmenu.curr < 0) {
@@ -501,8 +599,43 @@ group_page(
 				break;
 
 			case GLOBAL_LOOKUP_MESSAGEID:
-				if ((i = prompt_msgid()) != ART_UNAVAILABLE)
-					ret_code = enter_pager(i, FALSE);
+				{
+					t_bool only_unread = group->attribute->show_only_unread_arts;
+
+					if (only_unread)
+						toggle_read_unread(FALSE);
+					if ((i = prompt_msgid()) != ART_UNAVAILABLE)
+						ret_code = enter_pager(i, FALSE);
+#ifdef NNTP_ABLE
+					else {
+						const char *eyde = input_history[HIST_MESSAGE_ID][(hist_pos[HIST_MESSAGE_ID] - 1 + HIST_SIZE) % HIST_SIZE];
+						int sc = selmenu.curr;
+
+						if (eyde && *eyde) {
+							switch (show_article_by_msgid(eyde)) {
+								case LOOKUP_OK:
+									selmenu.curr = sc;
+									if (!index_group(curr_group, TRUE))
+										ret_code = GRP_RETSELECT; /* TODO: return GRP_RETSELECT; ? */
+									break;
+
+								case LOOKUP_UNAVAIL: /* check for !reading_saved_news? */
+									wait_message(2, _(txt_lookup_func_not_available));
+									break;
+
+								default:
+									wait_message(2, _(txt_art_unavailable));
+									break;
+							}
+						}
+					}
+#endif /* NNTP_ABLE */
+					if (ret_code == 0) {
+						if (only_unread)
+							toggle_read_unread(FALSE);
+						show_group_page();
+					}
+				}
 				break;
 
 			case GLOBAL_OPTION_MENU:			/* option menu */
@@ -568,7 +701,8 @@ group_page(
 				break;
 
 			case GLOBAL_QUIT:	/* return to group selection page */
-				if (num_of_tagged_arts && prompt_yn(_(txt_quit_despite_tags), TRUE) != 1)
+				/* TODO: add %d-num_of_tagged_arts counter in prompt? */
+				if (num_of_tagged_arts && prompt_yn(P_(txt_quit_despite_tags_sp[0], txt_quit_despite_tags_sp[1], num_of_tagged_arts), TRUE) != 1)
 					break;
 				if (xflag && TINRC_CONFIRM_SELECT && (prompt_yn(_(txt_confirm_select_on_exit), FALSE) != 1)) {
 					undo_auto_select_arts();
@@ -578,7 +712,8 @@ group_page(
 				break;
 
 			case GLOBAL_QUIT_TIN:		/* quit */
-				if (num_of_tagged_arts && prompt_yn(_(txt_quit_despite_tags), TRUE) != 1)
+				/* TODO: add %d-num_of_tagged_arts counter in prompt? */
+				if (num_of_tagged_arts && prompt_yn(P_(txt_quit_despite_tags_sp[0], txt_quit_despite_tags_sp[1], num_of_tagged_arts), TRUE) != 1)
 					break;
 				if (xflag && TINRC_CONFIRM_SELECT && (prompt_yn(_(txt_confirm_select_on_exit), FALSE) != 1)) {
 					undo_auto_select_arts();
@@ -709,7 +844,7 @@ group_page(
 					else
 						draw_subject_arrow();
 
-					info_message(tagged ? _(txt_prefix_untagged) : _(txt_prefix_tagged), txt_thread_singular);
+					info_message(tagged ? _(txt_untagged_thread) : _(txt_tagged_thread));
 				}
 				break;
 
@@ -761,8 +896,6 @@ group_page(
 				if (grpmenu.curr < 0)
 					info_message(_(txt_no_arts));
 				else {
-					const char *ptr;
-
 					if (range_active) {
 						/*
 						 * We are tied to following base[] here, not arts[], as we operate on
@@ -778,16 +911,13 @@ group_page(
 						}
 						range_active = FALSE;
 						show_group_page();
-						ptr = _(txt_base_article_range);
-					} else {
+					} else
 						art_mark(group, &arts[base[grpmenu.curr]], ART_WILL_RETURN);
-						ptr = _(txt_base_article);
-					}
 
 					show_group_title(TRUE);
 					build_sline(grpmenu.curr);
 					draw_subject_arrow();
-					info_message(_(txt_marked_as_unread), ptr);
+					info_message(range_active ? _(txt_base_article_range_marked_read) : _(txt_base_article_marked_read));
 				}
 				break;
 
@@ -939,7 +1069,8 @@ group_page(
 
 			case GLOBAL_TOGGLE_INFO_LAST_LINE:
 				tinrc.info_in_last_line = bool_not(tinrc.info_in_last_line);
-				show_group_page();
+				clear_message();
+				draw_subject_arrow();
 				break;
 
 			default:
@@ -1093,8 +1224,7 @@ toggle_read_unread(
 	if (force)
 		curr_group->attribute->show_only_unread_arts = TRUE;	/* Yes - really, we change it in a bit */
 
-	wait_message(0, _(txt_reading_arts),
-		(curr_group->attribute->show_only_unread_arts) ? _(txt_all) : _(txt_unread));
+	wait_message(0, (curr_group->attribute->show_only_unread_arts) ? _(txt_reading_all_arts) : _(txt_reading_unread_arts));
 
 	if (grpmenu.curr >= 0) {
 		if (curr_group->attribute->show_only_unread_arts || new_responses(grpmenu.curr))
@@ -1267,8 +1397,8 @@ build_sline(
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	wchar_t *wtmp, *wtmp2;
 #else
-	int fill, gap;
-	size_t len_start;
+	int fill;
+	size_t len_start, gap;
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 #ifdef USE_CURSES
@@ -1333,7 +1463,7 @@ build_sline(
 				free(buf);
 				break;
 
-			case 'F':	/* from */
+			case 'F':	/* from */ /* TODO: BiDi */
 				if (curr_group->attribute->show_author != SHOW_FROM_NONE) {
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 					get_author(FALSE, &arts[j], tmp, sizeof(tmp) - 1);
@@ -1350,11 +1480,12 @@ build_sline(
 #else
 					len_start = strwidth(buffer);
 					get_author(FALSE, &arts[j], buffer + strlen(buffer), grp_fmt.len_from);
-					fill = grp_fmt.len_from - (strwidth(buffer) - len_start);
-					gap = strlen(buffer);
-					for (k = 0; k < fill; k++)
-						buffer[gap + k] = ' ';
-					buffer[gap + fill] = '\0';
+					if ((fill = grp_fmt.len_from - (strwidth(buffer) - len_start)) > 0) {
+						gap = strlen(buffer);
+						for (k = 0; k < fill; k++)
+							buffer[gap + k] = ' ';
+						buffer[gap + fill] = '\0';
+					}
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 				}
 				break;
@@ -1435,7 +1566,7 @@ build_sline(
 				strcat(buffer, tin_ltoa(sbuf.score, grp_fmt.len_score));
 				break;
 
-			case 's':	/* thread/subject */
+			case 's':	/* thread/subject */ /* TODO: BiDi */
 				len = curr_group->attribute->show_author != SHOW_FROM_NONE ? grp_fmt.len_subj : grp_fmt.len_subj + grp_fmt.len_from;
 
 				if (sbuf.multipart_have > 1) /* We have a multipart msg so lets built our new header info. */
@@ -1457,11 +1588,12 @@ build_sline(
 #else
 				len_start = strwidth(buffer);
 				strncat(buffer, arts_sub, len);
-				fill = len - (strwidth(buffer) - len_start);
-				gap = strlen(buffer);
-				for (k = 0; k < fill; k++)
-					buffer[gap + k] = ' ';
-				buffer[gap + fill] = '\0';
+				if ((fill = len - (strwidth(buffer) - len_start)) > 0) {
+					gap = strlen(buffer);
+					for (k = 0; k < fill; k++)
+						buffer[gap + k] = ' ';
+					buffer[gap + fill] = '\0';
+				}
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 				break;
 
@@ -1493,7 +1625,7 @@ show_group_title(
 {
 	char buf[LEN], tmp[LEN], keyhelp[MAXKEYLEN], flag;
 	char *grpname;
-	int i, len, keyhelplen, art_cnt = 0, recent_art_cnt = 0, selected_art_cnt = 0, read_selected_art_cnt = 0, killed_art_cnt = 0;
+	int i, len, keyhelplen, art_cnt = 0, recent_art_cnt = 0, selected_art_cnt = 0, read_selected_art_cnt = 0, killed_art_cnt = 0, curr_getart_limit;
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	wchar_t *wtmp, *wtmp2;
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
@@ -1534,32 +1666,33 @@ show_group_title(
 		grpmenu.max, *txt_threading[curr_group->attribute->thread_articles]);
 
 	/* article count */
-	if ((cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit)
-		snprintf(tmp, sizeof(tmp), " %d/%d%"T_CHAR_FMT,
-			(cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit, art_cnt,
-			(wint_t) (curr_group->attribute->show_only_unread_arts ? tinrc.art_marked_unread : tinrc.art_marked_read));
+	curr_getart_limit = getart_limit_set_from_scope(curr_group) ? curr_group->attribute->getart_limit : (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
+
+	if (curr_getart_limit)
+		snprintf(tmp, sizeof(tmp), " %d/%d%"T_CHAR_FMT, curr_getart_limit, art_cnt,
+			(T_CHAR_TYPE) (curr_group->attribute->show_only_unread_arts ? tinrc.art_marked_unread : tinrc.art_marked_read));
 	else
 		snprintf(tmp, sizeof(tmp), " %d%"T_CHAR_FMT,
 			art_cnt,
-			(wint_t) (curr_group->attribute->show_only_unread_arts ? tinrc.art_marked_unread : tinrc.art_marked_read));
+			(T_CHAR_TYPE) (curr_group->attribute->show_only_unread_arts ? tinrc.art_marked_unread : tinrc.art_marked_read));
 	if (sizeof(buf) > strlen(buf) + strlen(tmp))
 		strcat(buf, tmp);
 
 	/* selected articles */
 	if (curr_group->attribute->show_only_unread_arts)
 		snprintf(tmp, sizeof(tmp), " %d%"T_CHAR_FMT,
-			selected_art_cnt, (wint_t) tinrc.art_marked_selected);
+			selected_art_cnt, (T_CHAR_TYPE) tinrc.art_marked_selected);
 	else
 		snprintf(tmp, sizeof(tmp), " %d%"T_CHAR_FMT" %d%"T_CHAR_FMT,
-			selected_art_cnt, (wint_t) tinrc.art_marked_selected,
-			read_selected_art_cnt, (wint_t) tinrc.art_marked_read_selected);
+			selected_art_cnt, (T_CHAR_TYPE) tinrc.art_marked_selected,
+			read_selected_art_cnt, (T_CHAR_TYPE) tinrc.art_marked_read_selected);
 	if (sizeof(buf) > strlen(buf) + strlen(tmp))
 		strcat(buf, tmp);
 
 	/* recent articles */
 	if (tinrc.recent_time) {
 		snprintf(tmp, sizeof(tmp), " %d%"T_CHAR_FMT,
-			recent_art_cnt, (wint_t) tinrc.art_marked_recent);
+			recent_art_cnt, (T_CHAR_TYPE) tinrc.art_marked_recent);
 
 		if (sizeof(buf) > strlen(buf) + strlen(tmp))
 			strcat(buf, tmp);
@@ -1567,7 +1700,7 @@ show_group_title(
 
 	/* killed articles */
 	snprintf(tmp, sizeof(tmp), " %d%"T_CHAR_FMT,
-		killed_art_cnt, (wint_t) tinrc.art_marked_killed);
+		killed_art_cnt, (T_CHAR_TYPE) tinrc.art_marked_killed);
 
 	if (sizeof(buf) > strlen(buf) + strlen(tmp))
 		strcat(buf, tmp);
@@ -1790,7 +1923,8 @@ group_catchup(
 	char buf[LEN];
 	int pyn = 1;
 
-	if (num_of_tagged_arts && prompt_yn(_(txt_catchup_despite_tags), TRUE) != 1)
+	/* TODO: add %d-num_of_tagged_arts counter in prompt? */
+	if (num_of_tagged_arts && prompt_yn(P_(txt_catchup_despite_tags_sp[0], txt_catchup_despite_tags_sp[1], num_of_tagged_arts), TRUE) != 1)
 		return 0;
 
 	snprintf(buf, sizeof(buf), _(txt_mark_arts_read), (func == CATCHUP_NEXT_UNREAD) ? _(txt_enter_next_unread_group) : "");
@@ -1832,12 +1966,16 @@ static t_bool
 prompt_getart_limit(
 	void)
 {
-	char *p;
+	const char *p;
 	t_bool ret = FALSE;
 
 	clear_message();
 	if ((p = tin_getline(_(txt_enter_getart_limit), 2, NULL, 0, FALSE, HIST_OTHER)) != NULL) {
 		tinrc.getart_limit = s2i(p, INT_MIN, INT_MAX);
+		if (scopes[0].attribute->getart_limit != tinrc.getart_limit) {
+			scopes[0].attribute->getart_limit = tinrc.getart_limit;
+			assign_attributes_to_groups();
+		}
 		if (!errno)
 			ret = TRUE;
 	}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/hashstr.c tin-2.6.5/src/hashstr.c
--- tin-2.6.4/src/hashstr.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/hashstr.c	2025-12-07 13:00:38.932724812 +0100
@@ -3,10 +3,10 @@
  *  Module    : hashstr.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2020-05-13
+ *  Updated   : 2025-12-07
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
 
  * All rights reserved.
  *
@@ -62,7 +62,7 @@ hash_str(
 {
 	const unsigned char *t = (const unsigned char *) s;
 	int len = 0;
-	long h;				/* result of hash: index into hash table */
+	unsigned long h;				/* result of hash: index into hash table */
 	struct t_hashnode **p;	/* used to descend the spillover structs */
 
 	if (s == NULL)
@@ -73,15 +73,17 @@ hash_str(
 		h = (h << 1) ^ *t++;
 		if (++len & 7)
 			continue;
-		h %= (long) HASHNODE_TABLE_SIZE;
+
+		h %= (unsigned long) HASHNODE_TABLE_SIZE;
 	}
-	h %= (long) HASHNODE_TABLE_SIZE;
+	h %= (unsigned long) HASHNODE_TABLE_SIZE;
 
 	p = &table[h];
 
 	while (*p) {
 		if (STRCMPEQ(s, (*p)->txt))
 			return (*p)->txt;
+
 		p = &(*p)->next;
 	}
 
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/header.c tin-2.6.5/src/header.c
--- tin-2.6.4/src/header.c	2024-12-15 14:01:15.000000000 +0100
+++ tin-2.6.5/src/header.c	2025-12-12 15:52:02.788724939 +0100
@@ -3,9 +3,9 @@
  *  Module    : header.c
  *  Author    : Urs Janssen <urs@tin.org>
  *  Created   : 1997-03-10
- *  Updated   : 2024-12-15
+ *  Updated   : 2025-12-12
  *
- * Copyright (c) 1997-2025 Urs Janssen <urs@tin.org>
+ * Copyright (c) 1997-2026 Urs Janssen <urs@tin.org>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -97,7 +97,7 @@ get_domain_name(
 	if (domain[0] == '/' && domain[1]) {
 		/* read domainname from specified file */
 		if ((fp = tin_fopen(domain, "r")) != NULL) {
-			while (fgets(buff, (int) sizeof(buff), fp) != NULL) {
+			while (fgets(buff, sizeof(buff), fp) != NULL) {
 				if (buff[0] == '#' || buff[0] == '\n')
 					continue;
 
@@ -122,7 +122,14 @@ get_domain_name(
 #ifdef HAVE_GETHOSTBYNAME
 #	define MAXLINELEN	1024
 #	define WSP	" \f\t\v"
-/* find FQDN - gethostbyaddr() */
+/*
+ * find FQDN - gethostbyaddr()
+ *
+ * TODO: we rely on gethostbyname() and gethostbyaddr(), but i.e,
+ *       __sortix__ "only" has the newer getaddrinfo()/getnameinfo()
+ *       so we fail to detect the FQDN (if not set via --with-domain-name)
+ *       and end up with force_no_post = TRUE
+ */
 const char *
 get_fqdn(
 	const char *host)
@@ -134,7 +141,7 @@ get_fqdn(
 	struct hostent *hp;
 	struct in_addr in = { 0 };
 
-	*fqdn = '\0';
+	fqdn[0] = '\0';
 	domain = NULL;
 	name[MAXHOSTNAMELEN] = '\0';
 
@@ -161,14 +168,11 @@ get_fqdn(
 			in.s_addr = (*hp->h_addr);
 #		endif /* HAVE_HOSTENT_H_ADDR_LIST */
 		}
-		return (
-			hp && strchr(hp->h_name, '.') ? hp->h_name :
 #		ifdef HAVE_INET_NTOA
-			inet_ntoa(in)
+		return (hp && strchr(hp->h_name, '.') ? hp->h_name : inet_ntoa(in));
 #		else
-			""
+		return (hp && strchr(hp->h_name, '.') ? hp->h_name : "");
 #		endif /* HAVE_INET_NTOA */
-			);
 	}
 #	endif /* HAVE_INET_ADDR */
 
@@ -181,15 +185,11 @@ get_fqdn(
 			in.s_addr = (*hp->h_addr);
 #	endif /* HAVE_HOSTENT_H_ADDR_LIST */
 	}
-	snprintf(fqdn, sizeof(fqdn), "%s", hp
-		? strchr(hp->h_name, '.')
-			? hp->h_name :
 #	ifdef HAVE_INET_NTOA
-			inet_ntoa(in)
+	snprintf(fqdn, sizeof(fqdn), "%s", hp ? strchr(hp->h_name, '.') ? hp->h_name : inet_ntoa(in) : "");
 #	else
-			""
+	snprintf(fqdn, sizeof(fqdn), "%s", hp ? strchr(hp->h_name, '.') ? hp->h_name : "" : "");
 #	endif /* HAVE_INET_NTOA */
-		: "");
 
 	if (!*fqdn || (fqdn[strlen(fqdn) - 1] <= '9')) { /* see FIXME above about IPv6 */
 		FILE *inf;
@@ -253,7 +253,7 @@ get_full_name(
 #ifndef DONT_HAVE_PW_GECOS
 	if ((pw = getpwuid(getuid())) != NULL) {
 		STRCPY(buf, pw->pw_gecos);
-		if ((p = strchr(buf, ',')))
+		if ((p = strchr(buf, ','))) /* cut off office, wphone, hphone */
 			*p = '\0';
 		if ((p = strchr(buf, '&'))) {
 			char tmp[128];
@@ -284,20 +284,25 @@ get_full_name(
 void
 get_from_name(
 	char *from_name,
+	size_t len,
 	const struct t_group *thisgrp)
 {
 	const char *fromhost = domain_name;
 
-	if (thisgrp && thisgrp->attribute->from && *thisgrp->attribute->from) {
-		strcpy(from_name, *thisgrp->attribute->from);
-		return;
-	}
+	assert(((void) "len must not be < 3", len > 2));	/* <@> */
 
-	sprintf(from_name, ((strpbrk(get_full_name(), "!()<>@,;:\\\".[]")) ? "\"%s\" <%s@%s>" : "%s <%s@%s>"), BlankIfNull(get_full_name()), userid, BlankIfNull(fromhost));
+	if (thisgrp && thisgrp->attribute->from && *thisgrp->attribute->from && strchr(*thisgrp->attribute->from, '@'))
+		snprintf(from_name, len, "%s", *thisgrp->attribute->from);
+	else {
+		if (tinrc.mail_address && *tinrc.mail_address && strchr(tinrc.mail_address, '@'))
+			snprintf(from_name, len, "%s", tinrc.mail_address);
+		else
+			snprintf(from_name, len, ((strpbrk(get_full_name(), "!()<>@,;:\\\".[]")) ? "\"%s\" <%s@%s>" : "%s <%s@%s>"), BlankIfNull(get_full_name()), userid, BlankIfNull(fromhost));
+	}
 
 #ifdef DEBUG
 	if (debug & DEBUG_MISC)
-		error_message(2, "FROM=[%s] USER=[%s] HOST=[%s] NAME=[%s]", from_name, userid, domain_name, BlankIfNull(get_full_name()));
+		error_message(2, "FROM=[%s] USER=[%s] HOST=[%s] NAME=[%s]", from_name, userid, BlankIfNull(fromhost), BlankIfNull(get_full_name()));
 #endif /* DEBUG */
 }
 
@@ -313,25 +318,24 @@ build_sender(
 {
 	const char *ptr;
 	static char sender[HEADER_LEN];
+	int n = 0;
 
 	sender[0] = '\0';
-
-	if ((ptr = get_full_name())) /* TODO: rfc2047 encode */
-		snprintf(sender, sizeof(sender), ((strpbrk(ptr, "\".:;<>@[]()\\")) ? "\"%s\"" : "%s "), ptr);
-
-	snprintf(sender + strlen(sender), sizeof(sender) - strlen(sender), "<%.*s@", LOGIN_NAME_MAX, userid);
+	ptr = get_full_name();
+	if (*ptr) { /* TODO: rfc2047 encode */
+		if ((n = snprintf(sender, sizeof(sender), ((strpbrk(ptr, "\".:;<>@[]()\\")) ? "\"%s\" " : "%s "), ptr)) < 2) /* >= 1 char real name + space */
+			n = 0;
+	}
 
 #	ifdef HAVE_GETHOSTBYNAME
 	ptr = get_fqdn(get_host_name());
 #	else
 	ptr = get_host_name();
 #	endif /* HAVE_GETHOSTBYNAME */
+	if (!*ptr)
+		return NULL;
 
-		/* intentionally do not fall back to *domain_name */
-
-	if (*ptr)
-		snprintf(sender + strlen(sender), sizeof(sender) - strlen(sender), "%s>", ptr);
-	else
+	if (snprintf(sender + n, sizeof(sender) - n, "<%.*s@%s>", LOGIN_NAME_MAX, userid, ptr) < 5) /* at least "<u@d>" */
 		return NULL;
 
 	return sender;
